// Imagine++ project
// Project:  Vect
// Author:   keriven
// Date:     2007/10/19

#include <iostream>
using namespace std;

class vect {
    // fields
    int n;
    double *t;
    // private functions
    void alloc(int N);
    void kill();
    void copy(const vect& v);
public:
    // "mandatory" constructors
    vect();
    vect(const vect& v);
    // destructor
    ~vect();
    // assignment
    vect& operator=(const vect& v);
    // additional constructor
    vect(int N);
};

void vect::alloc(int N) {
    n=N;
    if(n!=0)
        t=new double[n];
}

void vect::kill() {
    if(n!=0)
        delete[] t;
}

void vect::copy(const vect& v) {
    alloc(v.n);
    for(int i=0; i<n; i++) // OK even if n==0
        t[i]=v.t[i];
}

vect::vect() {
    alloc(0);
}

vect::vect(const vect& v) {
    copy(v);
}

vect::~vect() {
    kill();
}
  
vect& vect::operator=(const vect& v) {
    if(this!=&v) {
        kill();
        copy(v);
    }
    return *this;
}

vect::vect(int N) {
    alloc(N);
}

// To test copy constructor
vect f(vect a) {
    return a;
}

// To test everything works
int main()
{
    vect a,b(10),c(12),d;
    a=b;
    a=a;
    a=c;
    a=d;
    a=f(a);
    b=f(b);
    return 0;
}
